﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using TopoR_PCB_Classes;

namespace TopoRAdd
{
    public partial class ArrangeComponentsForm : Form
    {
        enum ArrangeType
        {
            circle
        }

        private class arrtypeitem
        {
            public ArrangeType arrtype { get; set; }
            public string name { get; set; }

            public arrtypeitem()
            {

            }
            public override string ToString()
            {
                return name;
            }
        }

        public dist dst { get; set; }

        public ArrangeComponentsForm()
        {
            InitializeComponent();
            cbSelectArrange.Items.Clear();
            cbSelectArrange.Items.Add(new arrtypeitem() { arrtype = ArrangeType.circle, name = "По кругу" });
        }

        private void lbComponents_SelectedValueChanged(object sender, EventArgs e)
        {

            var old = cbBaseComponent.SelectedItem;
            cbBaseComponent.Items.Clear();
            cbBaseComponent.Text = "";
            foreach (var a in lbComponents.SelectedItems)
            {
                cbBaseComponent.Items.Add(a);
            }
            cbBaseComponent.SelectedItem = old;
        }

        private void Arrange()
        {
            if (cbSelectArrange.SelectedItem == null)
            {
                MessageBox.Show("Не выбран вариант размещения!");
                return;
            }
            switch ((cbSelectArrange.SelectedItem as arrtypeitem).arrtype)
            {
                case ArrangeType.circle:
                    if (nuRadius.Value == 0)
                    {
                        MessageBox.Show("Радиус слишком мал!");
                        return;
                    }
                    double delta_angle = 2 * Math.PI / lbComponents.SelectedItems.Count;

                    double angle = 0;
                    double rotate_angle = 2 * Math.PI;
                    float _base_angle = 0;

                    if (cbBaseComponent.SelectedItem != null)
                    {
                        _base_angle = (cbBaseComponent.SelectedItem as ComponentsOnBoard.CompInstance)._angle;
                    }
                    if (chbNaoborot.Enabled && chbNaoborot.Checked)
                    {
                        rotate_angle = 0;
                    }
                    foreach (var a in lbComponents.SelectedItems)
                    {
                        (a as ComponentsOnBoard.CompInstance)._Org._x = Ut.UnitsConvert((float)((double)nuCenterX.Value + (double)nuRadius.Value * Math.Sin(angle)), rbMIL.Checked ? dist.mil : dist.mm, dst);
                        (a as ComponentsOnBoard.CompInstance)._Org._y = Ut.UnitsConvert((float)((double)nuCenterY.Value + (double)nuRadius.Value * Math.Cos(angle)), rbMIL.Checked ? dist.mil : dist.mm, dst);
                        if (chbRotate.Checked)
                        {
                            float result_angle = _base_angle + (float)(180 / Math.PI * rotate_angle);
                            (a as ComponentsOnBoard.CompInstance)._angle = result_angle > 360 ? 360 - result_angle : result_angle;
                        }
                        angle += delta_angle;
                        if (chbNaoborot.Enabled && chbNaoborot.Checked)
                        {
                            rotate_angle += delta_angle;
                        }
                        else
                        { 
                            rotate_angle -= delta_angle;
                        }                       
                    }
                    break;
            }
        }

        private void btAdd_Click(object sender, EventArgs e)
        {
            Arrange();
            DialogResult = DialogResult.OK;
        }

        private void chbRotate_CheckedChanged(object sender, EventArgs e)
        {
            chbNaoborot.Enabled = chbRotate.Checked;
        }

        private void ArrangeComponentsForm_Load(object sender, EventArgs e)
        {
            if ((Owner as MainWindow).docFST._ComponentsOnBoard?._Components?.Count > 0)
            {
                lbComponents.Items.AddRange((Owner as MainWindow).docFST._ComponentsOnBoard._Components.ToArray());
            }
        }
    }
}
